--- /dev/null	2019-07-14 19:12:33.000000000 +0000
+++ new/usr/src/cmd/sgs/tools/chkmsg.1l	2019-07-14 19:12:33.404851150 +0000
@@ -0,0 +1,118 @@
+.\" Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
+.\" Use is subject to license terms.
+.\"
+.\" CDDL HEADER START
+.\"
+.\" The contents of this file are subject to the terms of the
+.\" Common Development and Distribution License, Version 1.0 only
+.\" (the "License").  You may not use this file except in compliance
+.\" with the License.
+.\"
+.\" You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+.\" or http://www.opensolaris.org/os/licensing.
+.\" See the License for the specific language governing permissions
+.\" and limitations under the License.
+.\"
+.\" When distributing Covered Code, include this CDDL HEADER in each
+.\" file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+.\" If applicable, add the following below this CDDL HEADER, with the
+.\" fields enclosed by brackets "[]" replaced with your own identifying
+.\" information: Portions Copyright [yyyy] [name of copyright owner]
+.\"
+.\" CDDL HEADER END
+.\"
+.if n .tr \--
+.TH chkmsg 1l "Apr 5, 1997"
+.SH NAME
+chkmsg \- cross check messages
+.SH SYNOPSIS
+.B chkmsg
+.BI [ -64 ]
+.BI file
+.BI source_files ...
+.SH AVAILABILITY
+Internal to the linker group
+.SH DESCRIPTION
+chkmsg  checks the message identifiers defined in the input file
+and the message identifyer used in the input source_files. The input
+file is the input file which is used by the sgsmsg command.
+.P
+The chkmsg command reads the input file and
+generates two sets of message identifiers.
+The first set is
+the identifiers defined in between the _START_ and _END_ key words.
+These identifiers are intended to be referenced by MSG_INTL().
+This set is named as MSG_INTL_FROM_INPUT.
+.P
+The other set is
+the identifiers defined after the _END_ key words.
+These identifiers are intended to be referenced by MSG_ORIG().
+This set is named as MSG_ORIG_FROM_INPUT.
+.P
+The chkmsg command reads the specified input source_files and
+generates two sets of message identifiers. The first set is
+the message identifiers referenced by MSG_INTL() macro.
+This set is named as MSG_INTL_FROM_SRC.
+.P
+The other set is the message identifiers referenced by the
+MSG_ORIG() macro.
+This set is named as MSG_ORIG_FROM_SRC.
+.P
+The chkmsg command compares MSG_INTL_FROM_SRC and MSG_INTL_FROM_INPUT.
+If these two sets are different, the command gives the warning
+message and print the identifiers which are different.
+.P
+The chkmsg command compares MSG_ORIG_FROM_SRC and MSG_ORIG_FROM_INPUT.
+If these two sets are different, the command gives the warning
+message and print the identifiers which are different.
+.P
+The identifiers in MSG_INTL_FROM_SRC and MSG_ORIG_FROM_SRC are
+extracted from the source files only if they are
+directly passed to MSG_INTL() or MSG_ORIG(). Therefore, for example:
+.RS
+.nf
+.ft 3
+	char *msg;
+		|
+	msg = MSG_ERROR_01;
+		|
+	printf(MSG_INTL(msg));
+		|
+.fi
+.RE
+the identifyer MSG_ERROR_01 will not be included in MSG_INTL_FROM_SRC set.
+.P
+There are two key words which can be used in the input file
+to control whether the identifier will be extracted into
+MSG_{INTL,ORIG}_FROM_ORIG or not. If the identifyer are
+surrounded by _CHKMSG_SKIP_BEGIN_ {sparc,i386}
+and _CHKMSG_SKIP_END_ {sparc,i386}, then
+the identifiers will not be included in the output set.
+The architecture being checked should be specified after
+the key works.
+These key words should be specified in the comment lines.
+For example, the input file could contain:
+.RS
+.nf
+.ft 3
+	# _CHKMSG_SKIP_BEGIN_ sparc
+	@ MSG_ERROR_01	"This identifier is not defined."
+	# _CHKMSG_SKIP_END_ sparc
+.fi
+.RE
+.P
+It is assumed that the message identifier names are composed
+of only upper letters.
+.SH OPTIONS
+.TP 12
+.B \-64
+Use a 64-bit version of the machine type (i.e. sparc => sparcv9).
+Note that this option must be specified first on the command line.
+.SH "SEE ALSO"
+.BR gencat (1),
+.BR ld (1),
+.BR msgfmt (1),
+.BR catgets (3C),
+.BR gettext (3C).
+.BR sgsmsg (1ONBLD).
+.if n .tr \-\-
--- old/usr/src/cmd/sgs/tools/chkmsg.sh	2019-07-14 19:12:34.165536490 +0000
+++ new/usr/src/cmd/sgs/tools/chkmsg.sh	2019-07-14 19:12:34.181744877 +0000
@@ -24,7 +24,6 @@
 # Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
 #
-# ident	"%Z%%M%	%I%	%E% SMI"
 
 TOOLDIR="${SRC}/cmd/sgs/tools/"
 
--- old/usr/src/cmd/sgs/tools/i386/Makefile	2019-07-14 19:12:34.655190348 +0000
+++ new/usr/src/cmd/sgs/tools/i386/Makefile	2019-07-14 19:12:34.672466258 +0000
@@ -19,9 +19,6 @@
 #
 # CDDL HEADER END
 #
-#
-#ident	"%Z%%M%	%I%	%E% SMI"
-#
 # Copyright (c) 1996 by Sun Microsystems, Inc.
 # All rights reserved.
 
@@ -29,9 +26,7 @@
 
 .KEEP_STATE:
 
-all:		native $(PROGS) $(LIBS)
-
-native:		$(NATIVE)
+all:		$(NATIVE) $(PROGS) $(LIBS)
 
 install:	all $(ROOTPROGS) $(ROOTLIBS)
 
--- /dev/null	2019-07-14 19:12:35.000000000 +0000
+++ new/usr/src/cmd/sgs/tools/readme_revision	2019-07-14 19:12:35.501262809 +0000
@@ -0,0 +1,136 @@
+#!/usr/bin/perl -w
+#
+# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+#
+# Generate a revision number for the sgs linker components, based
+# on usr/src/cmd/sgs/tools/SUNWonld-README.
+#
+#	usage: readme_revision [-d] [readme-file]
+#
+# This revision number used to be the SCCS revision id for that file,
+# in the form 1.xxx (where xxx was the revision). There were two benefits:
+#
+#	(1) You could examine the sccs revision log to determine the CR
+#		of the putback that created the revision.
+#	(2) The revisions were monotonically increasing.
+#
+# In order to remove the hard wired dependence on sccs, this script generates
+# a replacement revision number, by returning the string '1.xxx', where
+# xxx is an integer giving the number of unique CR lines found in the file.
+# This means that the revision goes up by one for each CR we fix, which
+# makes intutive sense, and is similar to the way the SCCS revision worked.
+#
+# If this is a debug/development build (-d option), then we include
+# additional information at the end of the revision:
+#
+#	- Workspace name
+#	- user
+#	- CR # of last item in the readme file
+#	- date,
+#
+# This extra information is useful when we need to identify SUNWonld
+# linker packages in the field, and provides the information previously
+# supplied by (1) above.
+#
+
+use vars qw($script $usage $readme $cnt);
+use vars qw($debug $last_cr $wsname $date);
+
+# Use the basename of the name we're invoked under as the script name
+@_ = split /\//, $0;
+$script = $_[$#_];
+$usage = "usage: $script [-d] [readme-file]\n";
+
+$debug = 0;
+# Process the options
+while ((scalar(@ARGV) > 0) && ($_ = $ARGV[0],/^-/)) {
+  ARG: {
+	if (/^-d$/) {
+		$debug = 1;
+		last ARG;
+	}
+
+
+      # If it gets here, the option is unknown.
+      die $usage;
+  }
+    shift;
+}
+
+# Plain argument
+$cnt = scalar @ARGV;
+{
+	if ($cnt == 0) {
+		$readme = 'SUNWonld-README';
+		next;
+	}
+
+	if ($cnt == 1) {
+		$readme = $ARGV[0];
+		next;
+	}
+
+	die $usage;
+}
+
+
+open(FILE, $readme) || die "$script: Unable to open $readme\n";
+
+# At the date this script was put into service, the SCCS revision
+# of SUNWonld-README was 1.627, and SUNWonld-README had 588 unique
+# CRs. Revisions are supposed to always increase monotonically, so
+# we add 1000 to the number of unique CRs.
+#
+# This means that any linker with a version <1000 was built using
+# the SCCS revision, and any linker with version >=1000 was built
+# with this script.
+$cnt = 1000;
+
+while ($_ = <FILE>) {
+	chomp $_;
+
+	# If the line starts with a number, it is taken as a CR.
+	if ($_ =~ /^(\d+)\s/) {
+		$cnt++;
+		$last_cr = $1;
+	}
+}
+close FILE;
+
+# If this is a standard build, the revision # is all we want
+if ($debug == 0) {
+	print "1.$cnt\n";
+	exit 0;
+}
+
+# For debug mode, add diagnostic data
+($wsname = $ENV{'CODEMGR_WS'}) ne '' || ($wsname = 'unknown');
+@wsname = split /\//, $wsname;
+$wsname = $wsname[$#wsname];
+
+$date = `date +%m/%d/%y`;
+
+print "1.$cnt:$wsname-$ENV{USER}-$last_cr-$date\n";
+
+exit 0;
--- old/usr/src/cmd/sgs/tools/sparc/Makefile	2019-07-14 19:12:35.996002760 +0000
+++ new/usr/src/cmd/sgs/tools/sparc/Makefile	2019-07-14 19:12:36.014934177 +0000
@@ -19,9 +19,6 @@
 #
 # CDDL HEADER END
 #
-#
-#ident	"%Z%%M%	%I%	%E% SMI"
-#
 # Copyright (c) 1996 by Sun Microsystems, Inc.
 # All rights reserved.
 
@@ -29,9 +26,7 @@
 
 .KEEP_STATE:
 
-all:		native $(PROGS) $(LIBS)
-
-native:		$(NATIVE)
+all:		$(NATIVE) $(PROGS) $(LIBS)
 
 install:	all $(ROOTPROGS) $(ROOTLIBS)
 
--- old/usr/src/tools/Makefile	2019-07-14 19:12:36.473475893 +0000
+++ new/usr/src/tools/Makefile	2019-07-14 19:12:36.491133393 +0000
@@ -58,12 +58,19 @@
 	onbld \
 	protocmp \
 	protolist \
-	scripts
+	scripts \
+	sgs
 
 #
 #  special versions of commands for use only in build
 #
 UNSHIPPED_SUBDIRS = \
+	$(SGSMSG) \
+	$(SGSLIBCONV) \
+	$(SGSLIBELF) \
+	$(SGSLIBLDDBG) \
+	$(SGSLIBLD) \
+	$(SGSLD) \
 	localedef \
 	mandoc \
 	tic \
@@ -82,6 +89,8 @@
 	mbh_patch	\
 	btxld
 
+$(INTEL_BLD)sgs: aw
+
 LINTSUBDIRS= \
 	codereview \
 	ctf \
--- old/usr/src/tools/Makefile.tools	2019-07-14 19:12:36.932433081 +0000
+++ new/usr/src/tools/Makefile.tools	2019-07-14 19:12:36.948584142 +0000
@@ -55,6 +55,10 @@
 LDFLAGS=		$(MAPFILE.NES:%=-M%) $(MAPFILE.NED:%=-M%) \
 			    $(MAPFILE.PGA:%=-M%)
 
+# Unset CW_LINKER so we run the default.  We don't set LD here to avoid taking
+# the journey through LD_ALTEXEC unnecessarily.
+CW_LINKER=
+
 ROOTONBLDPROG=		$(PROG:%=$(ROOTONBLDBIN)/%)
 ROOTONBLDMACHPROG=	$(PROG:%=$(ROOTONBLDBINMACH)/%)
 ROOTONBLDSHFILES=	$(SHFILES:%=$(ROOTONBLDBIN)/%)
--- old/usr/src/tools/chk4ubin/Makefile	2019-07-14 19:12:37.401311067 +0000
+++ new/usr/src/tools/chk4ubin/Makefile	2019-07-14 19:12:37.417769370 +0000
@@ -28,6 +28,7 @@
 
 PROG	= chk4ubin
 
+DYNFLAGS += '-R$$ORIGIN/../../lib/$(MACH)'
 LDLIBS += -lelf
 
 LINTFLAGS += -ux
--- old/usr/src/tools/ctf/dwarf/Makefile.com	2019-07-14 19:12:37.850671933 +0000
+++ new/usr/src/tools/ctf/dwarf/Makefile.com	2019-07-14 19:12:37.866293605 +0000
@@ -68,7 +68,7 @@
 	pro_weaks.o
 
 include $(SRC)/lib/Makefile.lib
-
+include $(SRC)/tools/Makefile.tools
 
 FILEMODE =	0755
 SRCDIR =	$(SRC)/lib/libdwarf/common/
@@ -81,6 +81,7 @@
 # libdwarf not clean
 SMATCH=off
 
+DYNFLAGS += '-R$$ORIGIN/../../lib/$(MACH)'
 LDLIBS = -lelf -lc
 
 .KEEP_STATE:
--- old/usr/src/tools/cw/cw.1onbld	2019-07-14 19:12:38.317952088 +0000
+++ new/usr/src/tools/cw/cw.1onbld	2019-07-14 19:12:38.335762514 +0000
@@ -36,6 +36,7 @@
 .Op Fl -noecho
 .Fl -primary Ar compiler
 .Op Fl -shadow Ar compiler ...
+.Op Fl -linker Ar linker
 .Fl -
 .Ar compiler args ...
 .Sh DESCRIPTION
@@ -77,6 +78,11 @@
 .It Fl -shadow Ar compiler
 Specify a shadow compiler, which builds sources for the sake of checking code
 quality and compatibility, but has its output discarded.
+.It Fl -linker Ar linker
+Specify a link-editor to use in place of
+.Pa /usr/bin/ld .
+.Xr ld 1
+itself arranges for this to be executed by any subprocesses.
 .It Fl -noecho
 Do not echo the actual command line of any compilers invoked.
 .It Fl -versions
@@ -210,7 +216,8 @@
 .Sh SEE ALSO
 .Xr cc 1 ,
 .Xr CC 1 ,
-.Xr gcc 1
+.Xr gcc 1 ,
+.Xr ld 1
 .Sh BUGS
 The translations provided for gcc are not always exact and in some cases
 reflect local policy rather than actual equivalence.
--- old/usr/src/tools/cw/cw.c	2019-07-14 19:12:39.048956981 +0000
+++ new/usr/src/tools/cw/cw.c	2019-07-14 19:12:39.064536838 +0000
@@ -306,6 +306,7 @@
 typedef struct cw_ictx {
 	struct cw_ictx	*i_next;
 	cw_compiler_t	*i_compiler;
+	char		*i_linker;
 	struct aelist	*i_ae;
 	uint32_t	i_flags;
 	int		i_oldargc;
@@ -1209,14 +1210,6 @@
 			/* Just ignore -YS,... for now */
 			if (strncmp(arg, "S,", 2) == 0)
 				break;
-			if (strncmp(arg, "l,", 2) == 0) {
-				char *s = strdup(arg);
-				s[0] = '-';
-				s[1] = 'B';
-				newae(ctx->i_ae, s);
-				free(s);
-				break;
-			}
 			if (strncmp(arg, "I,", 2) == 0) {
 				char *s = strdup(arg);
 				s[0] = '-';
@@ -1468,6 +1461,9 @@
 		(void) fflush(stdout);
 	}
 
+	if (ctx->i_linker != NULL)
+		setenv("LD_ALTEXEC", ctx->i_linker, 1);
+
 	if (!(ctx->i_flags & CW_F_XLATE))
 		return;
 
@@ -1727,6 +1723,7 @@
 
 	static struct option longopts[] = {
 		{ "compiler", no_argument, NULL, 'c' },
+		{ "linker", required_argument, NULL, 'l' },
 		{ "noecho", no_argument, NULL, 'n' },
 		{ "primary", required_argument, NULL, 'p' },
 		{ "shadow", required_argument, NULL, 's' },
@@ -1746,6 +1743,10 @@
 		case 'C':
 			Cflg = B_TRUE;
 			break;
+		case 'l':
+			if ((main_ctx->i_linker = strdup(optarg)) == NULL)
+				nomem();
+			break;
 		case 'n':
 			nflg = B_TRUE;
 			break;
--- old/usr/src/tools/findunref/exception_list.open	2019-07-14 19:12:39.569829319 +0000
+++ new/usr/src/tools/findunref/exception_list.open	2019-07-14 19:12:39.581159557 +0000
@@ -143,7 +143,6 @@
 # Ignore internal packages, scripts, and tools that are intentionally not
 # built or used during a nightly.
 #
-./usr/src/cmd/sgs/packages
 ./usr/src/cmd/sgs/rtld.4.x
 ./usr/src/prototypes
 ./usr/src/cmd/pools/poold/com/sun/solaris/*/*/package.html
--- old/usr/src/tools/make/lib/makestate/Makefile.com	2019-07-14 19:12:40.034879368 +0000
+++ new/usr/src/tools/make/lib/makestate/Makefile.com	2019-07-14 19:12:40.052642650 +0000
@@ -18,6 +18,7 @@
 OBJECTS = ld_file.o lock.o
 
 include $(SRC)/lib/Makefile.lib
+include $(SRC)/tools/Makefile.tools
 include ../../../Makefile.com
 
 LIBS = $(DYNLIB)
--- old/usr/src/tools/make/lib/makestate/amd64/Makefile	2019-07-14 19:12:40.494333974 +0000
+++ new/usr/src/tools/make/lib/makestate/amd64/Makefile	2019-07-14 19:12:40.511818119 +0000
@@ -14,4 +14,7 @@
 include ../Makefile.com
 include $(SRC)/lib/Makefile.lib.64
 
+# Need to unset the alternate link-editor again, as Makefile.lib and
+# Makefile.tools don't interact well.
+
 install: all $(ROOTONBLDLIBMACH64)/libmakestate.so.1
--- /dev/null	2019-07-14 19:12:41.000000000 +0000
+++ new/usr/src/tools/sgs/Makefile	2019-07-14 19:12:40.992115987 +0000
@@ -0,0 +1,39 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2019, Richard Lowe.
+
+SUBDIRS =		\
+	include		\
+	ld		\
+	libconv		\
+	libelf		\
+	libld		\
+	liblddbg	\
+	sgsmsg
+
+all :=		TARGET= install
+install :=	TARGET= install
+clean :=	TARGET= clean
+clobber :=	TARGET= clobber
+
+ld: sgsmsg include libconv libelf libld
+libconv: sgsmsg include
+libelf: sgsmsg include
+libld: sgsmsg libelf libconv liblddbg include
+liblddbg: sgsmsg libconv include
+
+all install clean clobber: $(SUBDIRS)
+
+$(SUBDIRS): FRC
+	@cd $@; pwd; $(MAKE) $(TARGET)
+
+FRC:
--- /dev/null	2019-07-14 19:12:41.000000000 +0000
+++ new/usr/src/tools/sgs/Makefile.com	2019-07-14 19:12:41.226487382 +0000
@@ -0,0 +1,17 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2019, Richard Lowe.
+
+include $(SRC)/cmd/sgs/Makefile.com
+
+NATIVE_CPPFLAGS = -I. -I$(SRCDIR) -I$(SRCDIR)/common -I$(SGSHOME)/include -I$(SGSHOME)/include/$(MACH) \
+		-I../include $(CPPFLAGS.native) -I$(ELFCAP) -DNATIVE_BUILD
--- /dev/null	2019-07-14 19:12:41.000000000 +0000
+++ new/usr/src/tools/sgs/include/Makefile	2019-07-14 19:12:41.455046264 +0000
@@ -0,0 +1,68 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+# Copyright 2019, Richard Lowe.
+
+include ../../../Makefile.master
+
+#
+# To build a proper 'tools' version of the link-editor is not possible, as
+# we'll always depend on the ELF-related headers from the workspace, not the
+# system.
+#
+# We pull in the minimum amount of headers using an explicit list of "ELF-y"
+# headers to populate this directory, which we then search while building.
+#
+# This may not be enough on all occasions, judgement must be used to decide
+# between providing extra headers, and wrapping problematic code in conditions
+# on NATIVE_BUILD for a period of time.
+#
+
+ROOTHDRS=	dlfcn.h \
+		gelf.h \
+		libelf.h \
+		proc_service.h \
+		rtld_db.h \
+		link.h
+
+SYSHDRS=	sys/elf.h \
+		sys/elf_386.h \
+		sys/elf_SPARC.h \
+		sys/elf_notes.h \
+		sys/elf_amd64.h \
+		sys/elftypes.h \
+		sys/auxv.h \
+		sys/auxv_SPARC.h \
+		sys/auxv_386.h \
+		sys/avl.h \
+		sys/link.h \
+		sys/machelf.h \
+		sys/note.h \
+		sys/systeminfo.h
+
+sys:
+	$(MKDIR) -p sys
+
+%: $(SRC)/head/%
+	$(INS.file)
+
+sys/%: sys $(SRC)/uts/common/sys/%
+	$(INS.file)
+
+all install: $(SYSHDRS) $(ROOTHDRS)
+
+clean:
+
+clobber: clean
+	$(RM) $(SYSHDRS) $(ROOTHDRS)
+
+
+
--- /dev/null	2019-07-14 19:12:41.000000000 +0000
+++ new/usr/src/tools/sgs/ld/Makefile	2019-07-14 19:12:41.690247763 +0000
@@ -0,0 +1,41 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License, Version 1.0 only
+# (the "License").  You may not use this file except in compliance
+# with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+# Copyright (c) 1996 by Sun Microsystems, Inc.
+# All rights reserved.
+
+include		../Makefile.com
+include		../../Makefile.tools
+include		$(SGSHOME)/ld/Makefile.com
+
+LDLIBS = -L../libconv -L$(ROOTONBLDLIBMACH) -lld -lelf -lconv
+CPPFLAGS = $(NATIVE_CPPFLAGS)
+CFLAGS = $(NATIVE_CFLAGS)
+MAPFILES = $(SRCDIR)/common/mapfile-intf
+CW_LINKER =
+VAR_LD_LLDFLAGS=	'-R$$ORIGIN/../../lib/$(MACH)'
+VAR_LD_LLDFLAGS64 =	'-R$$ORIGIN/../../../lib/$(MACH64)'
+
+install: $(ROOTONBLDMACHPROG)
+
+.KEEP_STATE:
+
+include		$(SGSHOME)/ld/Makefile.targ
--- /dev/null	2019-07-14 19:12:41.000000000 +0000
+++ new/usr/src/tools/sgs/libconv/Makefile	2019-07-14 19:12:41.937877361 +0000
@@ -0,0 +1,43 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+#
+
+include		../Makefile.com
+include		$(SGSHOME)/libconv/Makefile.com
+
+CPPFLAGS = $(NATIVE_CPPFLAGS) -I$(SRC)/lib/libc/inc -I$(ELFCAP) \
+	-I$(SRC)/common/sgsrtcid \
+	-I$(SRC)/lib/libdemangle/common
+CFLAGS = $(NATIVE_CFLAGS)
+CW_LINKER =
+
+.PARALLEL:	$(PICS)
+.KEEP_STATE:
+
+install all:	$(LIBRARY)
+
+include		$(SGSHOME)/libconv/Makefile.targ
+
--- /dev/null	2019-07-14 19:12:42.000000000 +0000
+++ new/usr/src/tools/sgs/libelf/Makefile	2019-07-14 19:12:42.187668298 +0000
@@ -0,0 +1,48 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright (c) 1992, 2010, Oracle and/or its affiliates. All rights reserved.
+#
+
+include		../Makefile.com
+include		../../Makefile.tools
+include		$(SGSHOME)/libelf/Makefile.com
+
+CONVLIBDIR = -L../libconv
+CPPFLAGS = $(NATIVE_CPPFLAGS)
+CFLAGS = $(NATIVE_CFLAGS)
+SGSMSGTARG +=	$(SGSMSG32)
+CW_LINKER =
+
+.KEEP_STATE:
+
+install:	all $(ROOTONBLDLIBMACH)/$(DYNLIB) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+
+$(ROOTONBLDLIBMACH)/$(DYNLIB): $(PICS) $(ROOTONBLDLIBMACH)
+		$(BUILD.SO)
+		$(POST_PROCESS_SO)
+
+$(ROOTONBLDLIBMACH)/$(LIBLINKS): $(ROOTONBLDLIBMACH)/$(DYNLIB)
+		@$(RM) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+		$(SYMLINK) $(DYNLIB) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+
+include		$(SGSHOME)/libelf/Makefile.targ
--- /dev/null	2019-07-14 19:12:42.000000000 +0000
+++ new/usr/src/tools/sgs/libld/Makefile	2019-07-14 19:12:42.420581219 +0000
@@ -0,0 +1,56 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+#
+
+include		../Makefile.com
+include		../../Makefile.tools
+include		$(SGSHOME)/libld/Makefile.com
+
+.KEEP_STATE:
+
+CW_LINKER =
+
+CPPFLAGS = $(NATIVE_CPPFLAGS) -DUSE_LIBLD_MALLOC -I$(SRC)/lib/libc/inc \
+		    -I$(SRC)/uts/common/krtld -I$(SRC)/uts/sparc \
+		    $(VAR_LIBLD_CPPFLAGS)
+LDLIBS +=	-L$(ROOTONBLDLIBMACH) -L../libconv -lconv -llddbg -lelf -lc
+
+DYNFLAGS +=	$(VERSREF) '-R$$ORIGIN'
+CFLAGS = $(NATIVE_CFLAGS)
+
+all:		$(DYNLIB) $(LIBLINKS)
+
+install:	all $(ROOTONBLDLIBMACH)/$(DYNLIB) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+
+$(ROOTONBLDLIBMACH)/$(DYNLIB): $(PICS) $(ROOTONBLDLIBMACH)
+		$(BUILD.SO)
+		$(POST_PROCESS_SO)
+
+$(ROOTONBLDLIBMACH)/$(LIBLINKS): $(ROOTONBLDLIBMACH)/$(DYNLIB)
+		@$(RM) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+		$(SYMLINK) $(DYNLIB) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+
+include		$(SGSHOME)/libld/Makefile.targ
--- /dev/null	2019-07-14 19:12:42.000000000 +0000
+++ new/usr/src/tools/sgs/liblddbg/Makefile	2019-07-14 19:12:42.655815875 +0000
@@ -0,0 +1,51 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+
+include		../Makefile.com
+include		../../Makefile.tools
+include		$(SGSHOME)/liblddbg/Makefile.com
+
+.KEEP_STATE:
+
+CPPFLAGS = $(NATIVE_CPPFLAGS) -I$(SRC)/lib/libc/inc
+CFLAGS = $(NATIVE_CFLAGS)
+DYNFLAGS += -L../libconv
+CW_LINKER=
+SGSMSGTARG +=	$(SGSMSG32)
+
+all:		$(DYNLIB) $(LIBLINKS)
+
+install:	all $(ROOTONBLDLIBMACH)/$(DYNLIB) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+
+$(ROOTONBLDLIBMACH)/$(DYNLIB): $(PICS) $(ROOTONBLDLIBMACH)
+		$(BUILD.SO)
+		$(POST_PROCESS_SO)
+
+$(ROOTONBLDLIBMACH)/$(LIBLINKS): $(ROOTONBLDLIBMACH)/$(DYNLIB)
+		@$(RM) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+		$(SYMLINK) $(DYNLIB) $(ROOTONBLDLIBMACH)/$(LIBLINKS)
+
+include		$(SGSHOME)/liblddbg/Makefile.targ
--- /dev/null	2019-07-14 19:12:42.000000000 +0000
+++ new/usr/src/tools/sgs/sgsmsg/Makefile	2019-07-14 19:12:42.884455383 +0000
@@ -0,0 +1,75 @@
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+# Copyright (c) 2018, Joyent, Inc.
+# Copyright 2019 OmniOS Community Edition (OmniOSce) Association.
+
+#
+# Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
+# Use is subject to license terms.
+#
+
+#
+# Makefile to support tools used for linker development:
+#
+#  o	sgsmsg creates message headers/arrays/catalogs (a native tool).
+#
+# Note, these tools are not part of the product.
+#
+
+include		../Makefile.com
+include		../../Makefile.tools
+include		$(SRC)/cmd/Makefile.cmd
+
+
+PROG=	sgsmsg
+
+MAN1ONBLDFILES = sgsmsg.1onbld
+$(ROOTONBLDMAN1ONBLDFILES) := FILEMODE=	644
+
+OBJS= avl.o sgsmsg.o string_table.o findprime.o assfail.o
+
+FILEMODE=	0755
+
+CPPFLAGS = $(NATIVE_CPPFLAGS)
+CFLAGS = $(NATIVE_CFLAGS)
+CW_LINKER =
+
+# not linted
+SMATCH=off
+
+all: $(PROG)
+
+install: $(ROOTONBLDMACHPROG) $(ROOTONBLDMAN1ONBLDFILES)
+
+$(PROG): $(OBJS)
+	$(LINK.c) $(OBJS) -o $@ $(LDLIBS)
+
+%.o:	$(SGSCOMMON)/%.c
+	$(NATIVECC) $(DEBUG) $(NATIVE_CFLAGS) $(CPPFLAGS) -c $<
+
+avl.o:	$(SRC)/common/avl/avl.c
+	$(NATIVECC) $(DEBUG) $(NATIVE_CFLAGS) $(CPPFLAGS) -c \
+	    $(SRC)/common/avl/avl.c
+
+clean:
+	$(RM) $(OBJS)
+
+include $(SRC)/cmd/Makefile.targ
